using System;
using System.Web;
using System.Web.UI;

public partial class AsyncPageDemo : System.Web.UI.Page
{
  private System.Net.WebRequest _request;

  protected override void OnLoad(EventArgs e)
  {
    this.AddOnPreRenderCompleteAsync(new BeginEventHandler(this.BeginProcess), new EndEventHandler(this.EndProcess));
  }

  private IAsyncResult BeginProcess(object sender, EventArgs e, AsyncCallback callback, object extraData)
  {
    _request = System.Net.WebRequest.Create("http://feed.aspitalia.com/feed.xml");
    return _request.BeginGetResponse(callback, extraData);
  }

  private void EndProcess(IAsyncResult result)
  {
    string buffer = string.Empty;
    using (System.Net.WebResponse response = _request.EndGetResponse(result))
    {
      System.IO.StreamReader reader = new System.IO.StreamReader(response.GetResponseStream());
      buffer = reader.ReadToEnd();
      reader.Dispose();

      this.AsyncResult.Text = HttpUtility.HtmlEncode(buffer);
    }
  }
}
