using System;
using System.Data.SqlClient;
using System.Configuration;

namespace Aspitalia.Books.Web.Chapter9
{
    public partial class DataSet : System.Web.UI.Page
    {
        protected override void OnLoad(EventArgs e)
        {
            System.Data.DataSet ds = new System.Data.DataSet();
            
            // Creazione della connessione
            using(SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["SqlNorthwind"].ConnectionString))
            {
                // Apertura della connessione
                conn.Open();
                
                // Creazione del comando
                SqlCommand selectCmd = new SqlCommand("SELECT * FROM Customers;SELECT * FROM Suppliers;", conn);

                // Creazione dell'adapter
                SqlDataAdapter adapter = new SqlDataAdapter(selectCmd);

                // Popolamento dell'oggetto DataSet contenente due oggetti DataTable
                adapter.Fill(ds);

                // Il primo oggetto DataTable si riferisce ai clienti
                CustomersGrid.DataSource = ds.Tables[0];
                CustomersGrid.DataBind();

                // Il secondo oggetto DataTable si riferisce ai fornitori
                SuppliersGrid.DataSource = ds.Tables[1];
                SuppliersGrid.DataBind();
                
            } // La connessione viene chiusa automaticamente alla fine del blocco Using
        }
    }
}
