using System;
using System.Data.SqlClient;
using System.Configuration;

namespace Aspitalia.Books.Web.Chapter9
{
    public partial class ExecuteNonQuery : System.Web.UI.Page
    {
        protected override void OnLoad(EventArgs e)
        {
            // Creazione della connessione
            using (SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["SqlNorthwind"].ConnectionString))
            {
                // Apertura della connessione
                conn.Open();

                // Creazione del comando
                SqlCommand cmd = new SqlCommand("UPDATE Customers SET City='Bergamo' WHERE CustomerID=@CustomerID", conn);

                // Aggiungi un parametro
                cmd.Parameters.AddWithValue("@CustomerID", "MAGAA");

                // Ritorna il numero di righe interessate dal comando di aggiornamento
                int rowsAffected = cmd.ExecuteNonQuery();

                CommandLiteral.Text = cmd.CommandText.Replace(cmd.Parameters[0].ParameterName, "'" + cmd.Parameters[0].Value + "'");
                ResultLiteral.Text = rowsAffected.ToString();

            } // La connessione viene chiusa automaticamente alla fine del blocco Using
        }
    }
}
