Imports System
Imports System.IO
Imports System.Data
Imports System.Data.Common
Imports System.Configuration

Namespace Aspitalia.Books.Web.Chapter9

    Partial Class DbProviderFactory
        Inherits System.Web.UI.Page

        Protected Sub SelectDbProvider(ByVal sender As Object, ByVal e As EventArgs)

            Dim providerInvariantName As String = "[Nessuna selezione]"
            Dim connectionString As String = "[Nessuna selezione]"

            Dim dt As New DataTable()

            If (DbProviderSelect.SelectedIndex > 0) Then

                ' Nome invariante del managed data provider
                providerInvariantName = ConfigurationManager.ConnectionStrings(DbProviderSelect.SelectedValue).ProviderName

                ' Stringa di connessione
                connectionString = ConfigurationManager.ConnectionStrings(DbProviderSelect.SelectedValue).ConnectionString

                ' MS Access
                If (DbProviderSelect.SelectedValue.Equals("MdbNorthwind")) Then
                    connectionString = GetFullPathNameFromDBFileName(connectionString)
                    connectionString = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & connectionString
                End If

                ' Creazione dell'oggetto factory
                Dim factory As System.Data.Common.DbProviderFactory = DbProviderFactories.GetFactory(providerInvariantName)

                ' Interrogazione del database
                Using conn As DbConnection = factory.CreateConnection()

                    conn.ConnectionString = connectionString
                    conn.Open()

                    ' Modalit disconnessa: popolamento di un oggetto DataTable
                    Using adatpter As DbDataAdapter = factory.CreateDataAdapter()

                        Dim selectCmd As DbCommand = factory.CreateCommand()
                        selectCmd.CommandText = "SELECT * FROM Customers"
                        selectCmd.Connection = conn
                        adatpter.SelectCommand = selectCmd
                        adatpter.Fill(dt)

                    End Using

                End Using ' La connessione viene chiusa automaticamente alla fine del blocco Using

            End If

            ProviderLiteral.Text = providerInvariantName
            ConnectionStringLiteral.Text = connectionString

            ' Data binding della griglia di dati
            ResultGrid.DataSource = dt
            ResultGrid.DataBind()

        End Sub

        ' Ricava il percorso assoluto dal percorso relativo del file MDB
        Private Function GetFullPathNameFromDBFileName(ByVal relativeFileName As String) As String

            relativeFileName = relativeFileName.Replace("/", "\")

            If (relativeFileName.StartsWith("~\")) Then
                relativeFileName = relativeFileName.Substring(2)
            ElseIf (relativeFileName.StartsWith("\")) Then
                relativeFileName = relativeFileName.Substring(1)
            End If

            Return Path.Combine(HttpRuntime.AppDomainAppPath, relativeFileName)

        End Function


    End Class

End Namespace
