<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    protected void customerDataSource_Selected(object sender, ObjectDataSourceStatusEventArgs e)
    {
        // Intercetto l'eccezioni di tipo SqlException
        if (e.Exception is System.Data.SqlClient.SqlException)
        {
            // Mostro il messaggio d'errore
            this.errorLabel.Text = "Errore durante l'accesso al Database";
            // Inibisco l'eccezione
            e.ExceptionHandled = true;
        }
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>11.3</title>
</head>
<body>
    <form id="form1" runat="server">
        <div>
        <asp:ObjectDataSource ID="customerDataSource" runat="server"
            TypeName="ASPItalia.Books.Web.Chapter11.CustomerManager"
            SelectMethod="ListAll"
            EnablePaging="true"
            SelectCountMethod="GetTotalEntities"            
            DataObjectTypeName="ASPItalia.Books.Web.Chapter11.Customer"
            DeleteMethod="Delete"
            UpdateMethod="Update"
            ConflictDetection="CompareAllValues"
            OnSelected="customerDataSource_Selected" OldValuesParameterFormatString="old_{0}" />

        <asp:GridView ID="customerGridView" runat="server" AutoGenerateColumns="False" DataSourceID="customerDataSource"
            AllowPaging="true" PageSize="3"
            DataKeyNames="CustomerID">
            <Columns>
                <asp:BoundField DataField="CustomerID" HeaderText="CustomerID" SortExpression="CustomerID" />
                <asp:BoundField DataField="CompanyName" HeaderText="CompanyName" SortExpression="CompanyName" />
                <asp:BoundField DataField="Country" HeaderText="Country" SortExpression="Country" />
                <asp:CommandField ShowEditButton="true" ShowDeleteButton="true" ShowCancelButton="true" />
            </Columns>
        </asp:GridView>
        
        <asp:Label ID="errorLabel" runat="server" ForeColor="red" EnableViewState="false" />
        </div>
    </form>
</body>
</html>
