using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

namespace ASPItalia.Books.Web.Chapter11
{

    internal class FileSystemHierarchyData : IHierarchyData
    {

        private FileSystemInfo _pathInfo;
        private FileSystemHierarchyData _parent;
        private FileSystemHierarchicalDataSourceView dataSourceView;
        private string _viewPath;

        public FileSystemHierarchyData(FileSystemHierarchyData parent, FileSystemInfo pathInfo, string viewPath, FileSystemHierarchicalDataSourceView dataSourceView)
        {
            this._parent = parent;
            this._viewPath = viewPath;
            this._pathInfo = pathInfo;
            this.dataSourceView = dataSourceView;
        }

        #region IHierarchyData Members

        IHierarchicalEnumerable IHierarchyData.GetChildren()
        {
            // Solo se  una directory restituisco la lista delle directory figlie
            if (this._pathInfo is DirectoryInfo)
                return new FileSystemHierarchicalEnumerable((DirectoryInfo)_pathInfo, this, this._viewPath, this.dataSourceView);
            else
                return null;
        }

        IHierarchyData IHierarchyData.GetParent()
        {
            return _parent;
        }

        bool IHierarchyData.HasChildren
        {
            //get { return (this.path is DirectoryInfo && ((DirectoryInfo)path). }
            get { return this._pathInfo is DirectoryInfo; }
        }

        object IHierarchyData.Item
        {
            get { return this._pathInfo; }
        }

        string IHierarchyData.Path
        {
            get { return _viewPath; }
        }

        string IHierarchyData.Type
        {
            get { return this._pathInfo.GetType().Name; }
        }

        #endregion
    }
}