Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.Collections
Imports System.IO
Imports System.Collections.Generic
Imports System.ComponentModel


Namespace ASPItalia.Books.Web.Chapter11

    '/ <summary>
    '/ Vista flat rappresentante una view
    '/ </summary>
    Public Class FileSystemDataSourceView
        Inherits DataSourceView

        Private _owner As FileSystemDataSource

        Friend Sub New(ByVal owner As FileSystemDataSource, ByVal viewName As String)
            MyBase.New(owner, viewName)
            Me._owner = owner
        End Sub

        Protected Overrides Function ExecuteSelect(ByVal arguments As DataSourceSelectArguments) As IEnumerable
            arguments.RaiseUnsupportedCapabilitiesError(Me)

            Dim list As New List(Of FileSystemItem)

            Dim di As FileSystemInfo

            ' Aggiungo le directory
            For Each di In Me._owner.BaseDirectoryInfo.GetDirectories()
                list.Add(New FileSystemItem(di))
            Next

            ' Aggiungo i files
            For Each di In Me._owner.BaseDirectoryInfo.GetFiles()
                list.Add(New FileSystemItem(di))
            Next

            Return list
        End Function
    End Class

    Public Class FileSystemItem

        Private file As FileSystemInfo

        Friend Sub New(ByVal file As FileSystemInfo)
            Me.file = file
        End Sub

        Public ReadOnly Property Attributes() As FileAttributes
            Get
                Return Me.file.Attributes
            End Get
        End Property

        Public ReadOnly Property CreationTime() As DateTime
            Get
                Return Me.file.CreationTime
            End Get
        End Property

        Public ReadOnly Property Size() As Long
            Get
                If TypeOf Me.file Is FileInfo Then
                    Return (CType(File, FileInfo)).Length
                Else
                    Return 0
                End If
            End Get
        End Property

        Public ReadOnly Property Extension() As String
            Get
                Return Me.file.Extension
            End Get
        End Property

        Public Overridable ReadOnly Property FullName() As String
            Get
                Return Me.file.FullName
            End Get
        End Property

        Public ReadOnly Property LastAccessTime() As DateTime
            Get
                Return Me.file.LastAccessTime
            End Get
        End Property

        Public ReadOnly Property LastWriteTime() As DateTime
            Get
                Return Me.file.LastAccessTime
            End Get
        End Property

        Public ReadOnly Property Name() As String
            Get
                Return Me.file.Name
            End Get
        End Property

    End Class

End Namespace
