using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace ASPItalia.Books.Web.Chapter13
{

    public class TimeList : CompositeControl
    {
        
        private DropDownList list;
        private TextBox time;

        protected override void CreateChildControls()
        {
            base.CreateChildControls();
            
            // Creo la TextBox per inserire il valore
            time = new TextBox();
            time.Columns = 4;
            time.Text = "0";
            this.Controls.Add(time);
            
            // Creo la lista delle tipologie di tempo
            list = new DropDownList();
            list.Items.Add(new ListItem("giorni", "d"));
            list.Items.Add(new ListItem("minuti", "h"));
            list.Items.Add(new ListItem("secondi", "m"));
            this.Controls.Add(list);
        }

        public TimeSpan TimeSpan
        {
            get
            {
                EnsureChildControls();
                
                // Recupero il valore
                double t = Convert.ToDouble(this.time.Text);
                // In base all'unit calcolo il timespan
                switch (list.SelectedValue)
                {
                    case "d":
                        return System.TimeSpan.FromDays(t);
                    case "h":
                        return System.TimeSpan.FromHours(t);
                    case "m":
                        return System.TimeSpan.FromMinutes(t);
                }

                return System.TimeSpan.Zero;
            }
        }
    }

}