using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.ComponentModel;
using System.Collections.Generic;

public partial class Customers : System.Web.UI.UserControl, IWebPartField
{

    public event EventHandler SelectedCustomerChanged;

    public string SelectedCustomerID
    {
        get { return (string)this.GridView1.SelectedValue; }
    }

    [Personalizable(), WebBrowsable, WebDisplayName("Numero di righe")]
    public int PageSize
    {
        get { return this.GridView1.PageSize; }
        set { this.GridView1.PageSize = value; }
    }

    #region WebPart connection

    #region IWebPartField Members

    void IWebPartField.GetFieldValue(FieldCallback callback)
    {
        if (this.GridView1.SelectedDataKey != null)
            callback(this.GridView1.SelectedDataKey[0]);
        else
            callback(DBNull.Value);
    }

    System.ComponentModel.PropertyDescriptor IWebPartField.Schema
    {
        get
        {
            // Usato solo quando si usa una row come field
            return null;
        }
    }

    #endregion

    [ConnectionProvider("CustomerID")]
    public IWebPartField GetConnectionInterface()
    {
        return this;
    }

    #endregion

    protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (SelectedCustomerChanged != null)
            SelectedCustomerChanged(this, EventArgs.Empty);
    }
}
