Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.ComponentModel

Namespace ASPItalia.Books.Web.Chapter13

    Public Class Acronym
        Inherits WebControl
        Implements IPostBackEventHandler

        Private Shared EventClick As New Object()

        Private clicked As Boolean

        Public Sub New()
            MyBase.New(HtmlTextWriterTag.Acronym)
        End Sub

        Public Property Clickable() As Boolean
            Get
                Dim o As Object = Me.ViewState("Clickable")
                If Not o Is Nothing Then
                    Return CType(o, Boolean)
                Else
                    Return False
                End If
            End Get
            Set(ByVal Value As Boolean)
                Me.ViewState("Clickable") = value
            End Set
        End Property

        Public Property Text() As String
            Get
                Dim o As Object = Me.ViewState("Text")
                If Not o Is Nothing Then
                    Return CType(o, String)
                Else
                    Return String.Empty
                End If
            End Get
            Set(ByVal Value As String)
                Me.ViewState("Text") = value
            End Set
        End Property

        ' Il Click2  una versione pi ottimizzata
        Public Event Click As EventHandler

        <Category("Action"), Description("Evento click sull'acronimo")> _
        Public Custom Event Click2 As EventHandler
            AddHandler(ByVal value As EventHandler)
                MyBase.Events.AddHandler(Acronym.EventClick, value)
            End AddHandler
            RemoveHandler(ByVal value As EventHandler)
                MyBase.Events.RemoveHandler(Acronym.EventClick, value)
            End RemoveHandler
            RaiseEvent(ByVal sender As Object, ByVal e As eventargs)
                DirectCast(MyBase.Events(Acronym.EventClick), EventHandler).Invoke(sender, e)
            End RaiseEvent
        End Event

        Protected Overridable Sub OnClick2(ByVal e As EventArgs)
            RaiseEvent Click2(Me, e)
        End Sub


        Protected Overridable Sub OnClick(ByVal e As EventArgs)
            RaiseEvent Click(Me, e)
        End Sub

        Protected Overrides Function SaveControlState() As Object
            Dim o As Object = MyBase.SaveControlState()
            ' Se il control state base  nullo e clicked  false
            '  inutile che salvi qualcosa
            If o = Nothing And Not Me.clicked Then
                Return Nothing
            End If

            Return New Pair(o, Me.clicked)
        End Function

        Protected Overrides Sub LoadControlState(ByVal savedState As Object)
            Dim p As Pair = TryCast(savedState, Pair)
            If Not p Is Nothing Then
                ' Carico il primo valore nella classe base
                MyBase.LoadControlState(p.First)
                Me.clicked = CType(p.Second, Boolean)
            End If
        End Sub

        Protected Overrides Sub Render(ByVal writer As HtmlTextWriter)
            ' Se non  cliccabile rimuovo gli stili per simulare il link
            If Not Me.Clickable Then
                Me.Style.Remove(HtmlTextWriterStyle.Cursor)
                Me.Style.Remove(HtmlTextWriterStyle.TextDecoration)
            Else
                ' Se  cliccabile metto degli style per simulare il link
                Me.Style(HtmlTextWriterStyle.Cursor) = "pointer"
                Me.Style(HtmlTextWriterStyle.TextDecoration) = "underline"
            End If

            MyBase.Render(writer)
        End Sub

        Protected Overrides Sub RenderContents(ByVal writer As HtmlTextWriter)
            writer.Write(Me.Text)
        End Sub

        Protected Overrides Sub AddAttributesToRender(ByVal writer As HtmlTextWriter)
            MyBase.AddAttributesToRender(writer)

            If Me.Clickable Then
                writer.AddAttribute(HtmlTextWriterAttribute.Onclick, Me.Page.ClientScript.GetPostBackEventReference(Me, String.Empty))
            End If
        End Sub


#Region "IPostBackEventHandler Members"

        Private Sub RaisePostBackEvent(ByVal eventArgument As String) Implements IPostBackEventHandler.RaisePostBackEvent
            Me.OnClick(EventArgs.Empty)
        End Sub

#End Region
    end class

End Namespace