using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace ASPItalia.Books.Web.Chapter14
{

    public class ProcessModule : IHttpModule
    {

        #region IHttpModule Members

        void IHttpModule.Dispose()
        {

        }

        void IHttpModule.Init(HttpApplication context)
        {
            // Intercetto gli eventi di inizio e fine richiesta
            context.BeginRequest += new EventHandler(context_BeginRequest);
            context.EndRequest += new EventHandler(context_EndRequest);
        }

        #endregion

        private const String StartTime = "StartTime";

        void context_BeginRequest(object sender, EventArgs e)
        {
            // Salvo nel contesto i ticks iniziali
            HttpContext.Current.Items[StartTime] = Environment.TickCount;
        }

        void context_EndRequest(object sender, EventArgs e)
        {
            HttpContext context = HttpContext.Current;
            // Solo per le richieste di tipo Page
            if (context.Handler is Page)
            {
                // Recupero i ticks di inizio richiesta
                int startTime = (int)context.Items[StartTime];

                // Calcolo la differenza
                TimeSpan diff = TimeSpan.FromTicks((Environment.TickCount - startTime) * 10000);
                string s = String.Format("<div>{0},{1:00} secondi</div>", diff.Seconds, diff.Milliseconds);

                // Scrivo in coda l'HTML
                context.Response.Write(s);
            }
        }

    }
}