Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls

Namespace ASPItalia.Books.Web.Chapter14

    Public Class ProcessModule
        Implements IHttpModule

#Region "IHttpModule Members"

        Private Sub Dispose() Implements IHttpModule.Dispose
        End Sub

        Private Sub Init(ByVal context As HttpApplication) Implements IHttpModule.Init
            ' Intercetto gli eventi di inizio e fine richiesta
            AddHandler context.BeginRequest, New EventHandler(AddressOf context_BeginRequest)
            AddHandler context.EndRequest, New EventHandler(AddressOf context_EndRequest)
        End Sub

#End Region

        Private Const StartTime As String = "StartTime"

        Private Sub context_BeginRequest(ByVal sender As Object, ByVal e As EventArgs)
            ' Salvo nel contesto i ticks iniziali
            HttpContext.Current.Items(StartTime) = Environment.TickCount
        End Sub

        Private Sub context_EndRequest(ByVal sender As Object, ByVal e As EventArgs)
            Dim context As HttpContext = HttpContext.Current
            ' Solo per le richieste di tipo Page
            If TypeOf context.Handler Is Page Then
                ' Recupero i ticks di inizio richiesta
                Dim startTime As Integer = CType(context.Items(ProcessModule.StartTime), Integer)

                ' Calcolo la differenza
                Dim diff As TimeSpan = TimeSpan.FromTicks((Environment.TickCount - startTime) * 10000)
                Dim s As String = String.Format("<div>{0},{1:00} secondi</div>", diff.Seconds, diff.Milliseconds)

                ' Scrivo in coda l'HTML
                context.Response.Write(s)
            End If
        End Sub

    End Class
End Namespace