<%@ Page Language="C#" AutoEventWireup="true" masterpagefile="~/MasterPage.master" %>
<%@ outputcache duration="5" varybyparam="none" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
<script runat="server">
	protected void btnAggiungiInsert1_Click(object sender, EventArgs e) {
		Cache.Insert("chiave", "valore");
		lbl1.Text = "elemento aggiunto in cache";
	}

	protected void btnAggiungiInsert2_Click(object sender, EventArgs e) {
		Cache.Insert("chiave", "valore", new CacheDependency(Server.MapPath("data.xml")));
		lbl2.Text = "elemento aggiunto in cache con dipendenza dal file";
	}

	protected void btnAggiungiInsert3_Click(object sender, EventArgs e) {
		Cache["Dip1"] = DateTime.Now;
		Cache.Insert("chiave", "valore", new CacheDependency(null, new string[] { "Dip1" }));
		lbl3.Text = "elemento aggiunto in cache con dipendenza da chiave";
	}

	protected void btnAggiungiInsert4_Click(object sender, EventArgs e) {
		Cache.Insert("chiave", "valore", null, DateTime.Now.AddSeconds(10), Cache.NoSlidingExpiration);
		lbl4.Text = "elemento aggiunto in cache con scadenza il " + DateTime.Now.AddSeconds(10);
	}

	protected void btnAggiungiInsert5_Click(object sender, EventArgs e) {
		Cache.Insert("chiave", "valore", null, Cache.NoAbsoluteExpiration, new TimeSpan(0, 0, 10));
		lbl5.Text = "elemento aggiunto in cache con scadenza il a 10 secondi da ogni accesso";
	}

	protected void btnAggiungiInsert6_Click(object sender, EventArgs e) {
		Cache.Insert("chiave", "valore", null, DateTime.Now.AddSeconds(10), Cache.NoSlidingExpiration, CacheItemPriority.Default, new CacheItemRemovedCallback(onRemove));
		lbl6.Text = "elemento aggiunto in cache con callback";
	}

	protected void btnModificaChiaveDip_Click(object sender, EventArgs e) {
		Cache["dip1"] = DateTime.Now;
		lbl3.Text = "Chiave di dipendenza modificata";
	}

	protected void btnModificaFileDip_Click(object sender, EventArgs e) {
		System.IO.FileStream fs = new System.IO.FileStream(Server.MapPath("data.xml"), System.IO.FileMode.Append);
		fs.WriteByte(0);
		fs.Close();
		lbl2.Text = "File di dipendenza modificato";
	}

	protected void btnVisualizza_Click(object sender, EventArgs e) {
		if (Cache["chiave"] == null)
			lblVis.Text = "Oggetto scaduto";
		else
			lblVis.Text = Cache["chiave"].ToString();
	}

	private void onRemove(string key, object value, CacheItemRemovedReason reason) {
		string s = "Elemento rimosso dalla cache perch: ";
		if (reason == CacheItemRemovedReason.DependencyChanged) s += "Modificata dipendenza";
		else if (reason == CacheItemRemovedReason.Expired) s += "Scaduto il tempo";
		else if (reason == CacheItemRemovedReason.Removed) s += "Rimosso da codice";
		else s += "Rimosso dal Garbage Collector per liberare memoria";
		Log(s);
	}

	private void Log(string value) {
		//qui si pu loggare o fare qualunque altra cosa
	}
</script>
	<h4>Visualizzazione contenuto cache</h4>
	<asp:button id="btnVisualizza" runat="server" text="Visualizza" onclick="btnVisualizza_Click" />
	<asp:label id="lblVis" runat="server" />
	<hr />

	<h4>Esempio 17.12 - Aggiunta tramite metodo insert con chiave e valore</h4>
	<asp:button id="btnAggiungiInsert1" runat="server" text="Aggiungi" onclick="btnAggiungiInsert1_Click" />
	<asp:label id="lbl1" runat="server" />
	<hr />

	<h4>Esempio 17.13 - Aggiunta tramite metodo insert con chiave, valore e dipendenza da file</h4>
	<asp:button id="btnAggiungiInsert2" runat="server" text="Aggiungi" onclick="btnAggiungiInsert2_Click" />
	<asp:button id="btnModificaFileDip" runat="server" text="Modifica Dipendenza" onclick="btnModificaFileDip_Click" />
	<asp:label id="lbl2" runat="server" />
	<hr />

	<h4>Esempio 17.13 - Aggiunta tramite metodo insert con chiave, valore e dipendenza da altra chiave in cache</h4>
	<asp:button id="btnAggiungiInsert3" runat="server" text="Aggiungi" onclick="btnAggiungiInsert3_Click" />
	<asp:button id="btnModificaChiaveDip" runat="server" text="Modifica Dipendenza" onclick="btnModificaChiaveDip_Click" />
	<asp:label id="lbl3" runat="server" />
	<hr />

	<h4>Esempio 17.14 - Aggiunta tramite metodo insert con scadenza fissa tra 10 secondi</h4>
	<asp:button id="btnAggiungiInsert4" runat="server" text="Aggiungi" onclick="btnAggiungiInsert4_Click" />
	<asp:label id="lbl4" runat="server" />
	<hr />

	<h4>Esempio 17.14 - Aggiunta tramite metodo insert con scadenza a 10 secondi dal'ultimo accesso</h4>
	<asp:button id="btnAggiungiInsert5" runat="server" text="Aggiungi" onclick="btnAggiungiInsert5_Click" />
	<asp:label id="lbl5" runat="server" />
	<hr />

	<h4>Esempio 17.15 - Aggiunta tramite metodo insert con callback alla scadenza</h4>
	<asp:button id="btnAggiungiInsert6" runat="server" text="Aggiungi" onclick="btnAggiungiInsert6_Click" />
	<asp:label id="lbl6" runat="server" />
</asp:Content>