using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

namespace ASPItalia.Books.Web.Chapter20
{


    public class CustomerManager : EntityManager<Customer>
    {

        public CustomerManager()
        {
            if (this.GetTotalEntities() > 0) return;

            // Popolo per demo
            #region Populate
            Customer c;
            c = new Customer();
            c.CustomerID = "ALFKI";
            c.CompanyName= "Alfreds Futterkiste";
            c.ContactName = "Maria Anders";
            c.ContactTitle = "Sales Representative";
            c.Address = "Obere Str. 57";
            c.City = "Berlin";
            c.PostalCode = "12209";
            c.Country = "Germany";
            c.Phone = "030-0074321";
            c.Fax = "030-0076545";
            this.Add(c);

            c = new Customer();
            c.CustomerID = "ANATR";
            c.CompanyName = "Ana Trujillo Emparedados y helados";
            c.ContactName = "Ana Trujillo";
            c.ContactTitle = "Owner";
            c.Address = "Avda. de la Constitucin 2222";
            c.City = "Mxico D.F.";
            c.PostalCode = "05021";
            c.Country = "Mexico";
            c.Phone = "(5) 555-4729";
            c.Fax = "(5) 555-3745";
            this.Add(c);

            c = new Customer();
            c.CustomerID = "ANTON";
            c.CompanyName = "Antonio Moreno Taquera";
            c.ContactName = "Antonio Moreno";
            c.ContactTitle = "Owner";
            c.Address = "Mataderos  2312";
            c.City = "Mxico D.F.";
            c.PostalCode = "05023";
            c.Country = "Mexico";
            c.Phone = "(5) 555-3932";
            c.Fax = null;
            this.Add(c);

            c = new Customer();
            c.CustomerID = "FRANS";
            c.CompanyName = "Franchi S.p.A.";
            c.ContactName = "Paolo Accorti";
            c.ContactTitle = "Sales Representative";
            c.Address = "Via Monte Bianco 34";
            c.City = "Torino";
            c.PostalCode = "10100";
            c.Country = "Italy";
            c.Phone = "011-4988260";
            c.Fax = "011-4988261";
            this.Add(c);

            c = new Customer();
            c.CustomerID = "GREAL";
            c.CompanyName = "Great Lakes Food Market";
            c.ContactName = "Howard Snyder";
            c.ContactTitle = "Marketing Manager";
            c.Address = "2732 Baker Blvd.";
            c.City = "Eugene";
            c.Region = "OR";
            c.PostalCode = "97403";
            c.Country = "USA";
            c.Phone = "(503) 555-7555";
            c.Fax = null;
            this.Add(c);
            #endregion
        }

        protected override Customer FindEntity(List<Customer> cache, Customer entity)
        {
            return cache.Find(delegate(Customer c)
            {
                return (c.CustomerID == entity.CustomerID);
            });
        }

        public Customer GetSingle(string customerID)
        {
            Customer c = new Customer();
            c.CustomerID = customerID;
            return this.GetSingle(c);
        }
    }
}